<div class="ngst-container">
  <div class="ngst-header">
    <!--Title-->
    <div class="ngst-title">{{title}}</div>

    <!--Add button-->
    <div class="ngst-button-container">
      <button color="primary" mat-mini-fab class="ngst-add-button" *ngIf="canCreate" (click)="addRow()">
        <mat-icon>add</mat-icon>
      </button>
    </div>
  </div>

  <!--Table-->
  <mat-table #table [dataSource]="rawDataSource" matSort (matSortChange)="doSort()">
    <!--Actions-->
    <ng-container matColumnDef="ngst-actions" *ngIf="showActions">
      <mat-header-cell *matHeaderCellDef>
        <button *ngIf="filters" mat-icon-button (click)="toggleFilters()" >
          <mat-icon>filter_list</mat-icon>
        </button>
      </mat-header-cell>
      <mat-cell *matCellDef="let row">
        <button mat-icon-button
                matTooltip="{{action.tooltip}}"
                [disabled]="checkDisabled(row, action)"
                ngstStopPropogation
                *ngFor="let action of combinedActions"
                (click)="runAction(action, row)"
                [ngClass]=" row.disabled ? 'ngst-disabled-btn ngst-action-'+ action.name : 'ngst-action-' + action.name">
          <mat-icon>{{action.icon}}</mat-icon>
        </button>
      </mat-cell>
    </ng-container>

    <!--Columns-->
    <ng-container *ngFor="let column of columns" [matColumnDef]="column.label">
      <mat-header-cell *matHeaderCellDef mat-sort-header>{{column.label}}</mat-header-cell>
      <mat-cell *matCellDef="let row">
        <ng-container *ngIf="column.customComponent && !row.filterRow">
          <ngst-dynamic-cell [component]="column.customComponent" [data]="row[column.accessor]"></ngst-dynamic-cell>
        </ng-container>

        <!--Edit-->
        <div *ngIf="!column.customComponent && !row.filterRow">
          <ng-container *ngIf="row === editRow && column === editColumn && column.editable && canEdit">
            <!--Polymorphism is hot!-->
            <ngst-input-container [item]="row"
                                  [column]="column"
                                  [showPlaceholder]="false"
                                  (changedEmitter)="changeRow(row, column, $event)">
            </ngst-input-container>
          </ng-container>

          <!--Display-->
          <ng-container *ngIf="row != editRow || column != editColumn || !column.editable || !canEdit">

            <!--Not Editable-->
            <ng-container *ngIf="!column.editable || !canEdit || row.disabled">
              <div *ngIf="!isEmpty(column.getRowValue(row))"
                   [class.ngst-clickable]="canClick"
                   [ngClass]="{'ngst-disabled' : row.disabled}"
                   class="ngst-not-editable {{columnLabel(column)}}">
                <div>
                  <div [innerHTML]="column.formatValue(row)"></div>
                  <mat-error *ngIf="column.getRowValueError(row)">{{column.getRowValueError(row)}}</mat-error>
                </div>
              </div>
              <div *ngIf="isEmpty(column.getRowValue(row))"
                   [ngClass]="{'ngst-disabled' : row.disabled}"
                   [class.ngst-clickable]="canClick"
                   class="ngst-not-editable ngst-empty {{columnLabel(column)}}">
                <div>
                  empty
                  <mat-error *ngIf="column.getRowValueError(row)">{{column.getRowValueError(row)}}</mat-error>
                </div>
              </div>
            </ng-container>

            <!--Editable-->
            <ng-container *ngIf="column.editable && canEdit && !row.disabled">
              <div *ngIf="!isEmpty(column.getRowValue(row))"
                   (click)="clickCell(row, column)" ngstStopPropogation
                   class="ngst-editable {{columnLabel(column)}}">
                <div>
                  <div [innerHTML]="column.formatValue(row)"></div>
                  <mat-error *ngIf="column.getRowValueError(row)">{{column.getRowValueError(row)}}</mat-error>
                </div>
              </div>
              <div *ngIf="isEmpty(column.getRowValue(row))"
                   (click)="clickCell(row, column)" ngstStopPropogation
                   class="ngst-editable ngst-empty {{columnLabel(column)}}">
                <div>
                  empty
                  <mat-error *ngIf="column.getRowValueError(row)">{{column.getRowValueError(row)}}</mat-error>
                </div>
              </div>
            </ng-container>
          </ng-container>
        </div>
      </mat-cell>
    </ng-container>

    <ng-container matColumnDef="expandedDetail">
      <mat-header-cell *matHeaderCellDef class="filterRow">
        <mat-cell *ngIf="showActions" class="mat-column-ngst-actions">
          <button mat-icon-button (click)="clearFilters()">
            <mat-icon>clear</mat-icon>
          </button>
        </mat-cell>
        <mat-cell *ngFor="let column of columns">
          <ngst-filter-cell [column]="column" (applyFilter)="applyFilter($event, column)" class="filter-cell"></ngst-filter-cell>
        </mat-cell>
      </mat-header-cell>
    </ng-container>

    <mat-header-row *matHeaderRowDef="columnIndexes"></mat-header-row>
    <mat-header-row *matHeaderRowDef="['expandedDetail']" [@detailExpand]="filtersOpen ? 'expanded' : 'collapsed'"></mat-header-row>
    <mat-row *matRowDef="let row; columns: columnIndexes;"
             [class.ngst-clickable]="canClick"
             (click)="clickRow(row)"></mat-row>
  </mat-table>

  <!--Paginator-->
  <mat-paginator #paginator
                 [pageSize]="pageSize"
                 [length]="rows"
                 [pageSizeOptions]="[5, 10, 25, 100]"
                 [showFirstLastButtons]="true">
  </mat-paginator>
</div>

